package com.tptj.demo.hg.system.option.provider;

import com.fr.decision.authority.base.AuthorityConstants;
import com.fr.decision.authority.base.constant.AuthorityStaticItemId;
import com.fr.decision.fun.impl.AbstractSystemOptionProvider;
import com.fr.decision.web.MainComponent;
import com.fr.intelli.record.Focus;
import com.fr.plugin.transform.ExecuteFunctionRecord;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.web.struct.Atom;
import com.fr.web.struct.Component;
import com.fr.web.struct.browser.RequestClient;
import com.fr.web.struct.category.ScriptPath;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/6/11
 **/
@EnableMetrics
public class Demo extends AbstractSystemOptionProvider {
    private static final String DEC_MANAGEMENT_DEMO_ID = "DEC_MANAGEMENT_DEMO_ID";
    @Override
    @Focus(id="com.tptj.demo.hg.system.option.provider.v10",text = "SystemOptionProvider")
    public String id() {
        return DEC_MANAGEMENT_DEMO_ID;
    }

    @Override
    public String displayName() {
        return "Demo";
    }

    @Override
    public int sortIndex() {
        return 0;
    }

    @Override
    public String parentId() {
        //一般说来用不到，因为决策平台自身可折叠的管理菜单本身只有
        return AuthorityStaticItemId.DEC_MANAGEMENT_MAINTENANCE_ID;
    }

    @Override
    public String fullPath() {
        //用来控制后台实际权限判断的，
        return AuthorityStaticItemId.DEC_MANAGEMENT_ID+
                AuthorityConstants.FULL_PATH_SPLITTER+
                AuthorityStaticItemId.DEC_MANAGEMENT_USER_ID;
    }

    @Override
    public Atom attach() {
        return MainComponent.KEY;
    }

    @Override
    public Atom[] clients() {
        return new Atom[]{
                new Component() {
                    @Override
                    public ScriptPath script( RequestClient client ) {
                        return ScriptPath.build("com/tptj/demo/hg/system/option/provider/plugin.js");
                    }
                }
        };
    }
}
